VirtualBox

source: vbox/trunk/src/VBox/Installer/darwin/DiskImage/VirtualBox_Uninstall.tool@ 56621

Last change on this file since 56621 was 56621, checked in by vboxsync, 10 years ago

Installer/darwin: Put the CLI bits in /usr/local/bin instead of /usr/bin to be compatible with El Capitan.

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
  • Property svn:keywords set to Author Date Id Revision
File size: 11.8 KB
Line 
1#!/bin/bash
2# $Id: VirtualBox_Uninstall.tool 56621 2015-06-24 13:07:35Z vboxsync $
3## @file
4# VirtualBox Uninstaller Script.
5#
6
7#
8# Copyright (C) 2007-2015 Oracle Corporation
9#
10# This file is part of VirtualBox Open Source Edition (OSE), as
11# available from http://www.virtualbox.org. This file is free software;
12# you can redistribute it and/or modify it under the terms of the GNU
13# General Public License (GPL) as published by the Free Software
14# Foundation, in version 2 as it comes in the "COPYING" file of the
15# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
16# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
17#
18
19# Override any funny stuff from the user.
20export PATH="/bin:/usr/bin:/sbin:/usr/sbin:$PATH"
21
22#
23# Display a simple welcome message first.
24#
25echo ""
26echo "Welcome to the VirtualBox uninstaller script."
27echo ""
28
29#
30# Check for arguments and display
31#
32my_default_prompt=0
33if test "$#" != "0"; then
34 if test "$#" != "1" -o "$1" != "--unattended"; then
35 echo "Error: Unknown argument(s): $*"
36 echo ""
37 echo "Usage: uninstall.sh [--unattended]"
38 echo ""
39 echo "If the '--unattended' option is not given, you will be prompted"
40 echo "for a Yes/No before doing the actual uninstallation."
41 echo ""
42 exit 4;
43 fi
44 my_default_prompt="Yes"
45fi
46
47#
48# Collect directories and files to remove.
49# Note: Do NOT attempt adding directories or filenames with spaces!
50#
51declare -a my_directories
52declare -a my_files
53
54# Users files first
55test -f "${HOME}/Library/LaunchAgents/org.virtualbox.vboxwebsrv.plist" && my_files+=("${HOME}/Library/LaunchAgents/org.virtualbox.vboxwebsrv.plist")
56
57test -d /Library/StartupItems/VirtualBox/ && my_directories+=("/Library/StartupItems/VirtualBox/")
58test -d /Library/Receipts/VBoxStartupItems.pkg/ && my_directories+=("/Library/Receipts/VBoxStartupItems.pkg/")
59
60test -d "/Library/Application Support/VirtualBox/LaunchDaemons/" && my_directories+=("/Library/Application Support/VirtualBox/LaunchDaemons/")
61test -d "/Library/Application Support/VirtualBox/VBoxDrv.kext/" && my_directories+=("/Library/Application Support/VirtualBox/VBoxDrv.kext/")
62test -d "/Library/Application Support/VirtualBox/VBoxUSB.kext/" && my_directories+=("/Library/Application Support/VirtualBox/VBoxUSB.kext/")
63test -d "/Library/Application Support/VirtualBox/VBoxNetFlt.kext/" && my_directories+=("/Library/Application Support/VirtualBox/VBoxNetFlt.kext/")
64test -d "/Library/Application Support/VirtualBox/VBoxNetAdp.kext/" && my_directories+=("/Library/Application Support/VirtualBox/VBoxNetAdp.kext/")
65# Pre 4.3.0rc1 locations:
66test -d /Library/Extensions/VBoxDrv.kext/ && my_directories+=("/Library/Extensions/VBoxDrv.kext/")
67test -d /Library/Extensions/VBoxUSB.kext/ && my_directories+=("/Library/Extensions/VBoxUSB.kext/")
68test -d /Library/Extensions/VBoxNetFlt.kext/ && my_directories+=("/Library/Extensions/VBoxNetFlt.kext/")
69test -d /Library/Extensions/VBoxNetAdp.kext/ && my_directories+=("/Library/Extensions/VBoxNetAdp.kext/")
70# Tiger support is obsolete, but we leave it here for a clean removing of older
71# VirtualBox versions
72test -d /Library/Extensions/VBoxDrvTiger.kext/ && my_directories+=("/Library/Extensions/VBoxDrvTiger.kext/")
73test -d /Library/Extensions/VBoxUSBTiger.kext/ && my_directories+=("/Library/Extensions/VBoxUSBTiger.kext/")
74test -d /Library/Receipts/VBoxKEXTs.pkg/ && my_directories+=("/Library/Receipts/VBoxKEXTs.pkg/")
75
76test -f /usr/bin/VirtualBox && my_files+=("/usr/bin/VirtualBox")
77test -f /usr/bin/VBoxManage && my_files+=("/usr/bin/VBoxManage")
78test -f /usr/bin/VBoxVRDP && my_files+=("/usr/bin/VBoxVRDP")
79test -f /usr/bin/VBoxHeadless && my_files+=("/usr/bin/VBoxHeadless")
80test -f /usr/bin/vboxwebsrv && my_files+=("/usr/bin/vboxwebsrv")
81test -f /usr/bin/VBoxBalloonCtrl && my_files+=("/usr/bin/VBoxBalloonCtrl")
82test -f /usr/bin/VBoxAutostart && my_files+=("/usr/bin/VBoxAutostart")
83test -f /usr/bin/VBoxDTrace && my_files+=("/usr/bin/VBoxDTrace")
84test -f /usr/bin/vbox-img && my_files+=("/usr/bin/vbox-img")
85test -f /usr/local/bin/VirtualBox && my_files+=("/usr/local/bin/VirtualBox")
86test -f /usr/local/bin/VBoxManage && my_files+=("/usr/local/bin/VBoxManage")
87test -f /usr/local/bin/VBoxVRDP && my_files+=("/usr/local/bin/VBoxVRDP")
88test -f /usr/local/bin/VBoxHeadless && my_files+=("/usr/local/bin/VBoxHeadless")
89test -f /usr/local/bin/vboxwebsrv && my_files+=("/usr/local/bin/vboxwebsrv")
90test -f /usr/local/bin/VBoxBalloonCtrl && my_files+=("/usr/local/bin/VBoxBalloonCtrl")
91test -f /usr/local/bin/VBoxAutostart && my_files+=("/usr/local/bin/VBoxAutostart")
92test -f /usr/local/bin/VBoxDTrace && my_files+=("/usr/local/bin/VBoxDTrace")
93test -f /usr/local/bin/vbox-img && my_files+=("/usr/local/bin/vbox-img")
94test -d /Library/Receipts/VirtualBoxCLI.pkg/ && my_directories+=("/Library/Receipts/VirtualBoxCLI.pkg/")
95test -f /Library/LaunchDaemons/org.virtualbox.startup.plist && my_files+=("/Library/LaunchDaemons/org.virtualbox.startup.plist")
96
97test -d /Applications/VirtualBox.app/ && my_directories+=("/Applications/VirtualBox.app/")
98test -d /Library/Receipts/VirtualBox.pkg/ && my_directories+=("/Library/Receipts/VirtualBox.pkg/")
99
100# legacy
101test -d /Library/Receipts/VBoxDrv.pkg/ && my_directories+=("/Library/Receipts/VBoxDrv.pkg/")
102test -d /Library/Receipts/VBoxUSB.pkg/ && my_directories+=("/Library/Receipts/VBoxUSB.pkg/")
103
104# python stuff
105python_versions="2.3 2.5 2.6 2.7"
106for p in $python_versions; do
107 test -f /Library/Python/$p/site-packages/vboxapi/VirtualBox_constants.py && my_files+=("/Library/Python/$p/site-packages/vboxapi/VirtualBox_constants.py")
108 test -f /Library/Python/$p/site-packages/vboxapi/VirtualBox_constants.pyc && my_files+=("/Library/Python/$p/site-packages/vboxapi/VirtualBox_constants.pyc")
109 test -f /Library/Python/$p/site-packages/vboxapi/__init__.py && my_files+=("/Library/Python/$p/site-packages/vboxapi/__init__.py")
110 test -f /Library/Python/$p/site-packages/vboxapi/__init__.pyc && my_files+=("/Library/Python/$p/site-packages/vboxapi/__init__.pyc")
111 test -f /Library/Python/$p/site-packages/vboxapi-1.0-py$p.egg-info && my_files+=("/Library/Python/$p/site-packages/vboxapi-1.0-py$p.egg-info")
112 test -d /Library/Python/$p/site-packages/vboxapi/ && my_directories+=("/Library/Python/$p/site-packages/vboxapi/")
113done
114
115#
116# Collect KEXTs to remove.
117# Note that the unload order is significant.
118#
119declare -a my_kexts
120for kext in org.virtualbox.kext.VBoxUSB org.virtualbox.kext.VBoxNetFlt org.virtualbox.kext.VBoxNetAdp org.virtualbox.kext.VBoxDrv; do
121 if /usr/sbin/kextstat -b $kext -l | grep -q $kext; then
122 my_kexts+=("$kext")
123 fi
124done
125
126#
127# Collect packages to forget
128#
129my_pb='org\.virtualbox\.pkg\.'
130my_pkgs=`/usr/sbin/pkgutil --pkgs="${my_pb}vboxkexts|${my_pb}vboxstartupitems|${my_pb}virtualbox|${my_pb}virtualboxcli"`
131
132#
133# Did we find anything to uninstall?
134#
135if test -z "${my_directories[*]}" -a -z "${my_files[*]}" -a -z "${my_kexts[*]}" -a -z "$my_pkgs"; then
136 echo "No VirtualBox files, directories, KEXTs or packages to uninstall."
137 echo "Done."
138 exit 0;
139fi
140
141#
142# Look for running VirtualBox processes and warn the user
143# if something is running. Since deleting the files of
144# running processes isn't fatal as such, we will leave it
145# to the user to choose whether to continue or not.
146#
147# Note! comm isn't supported on Tiger, so we make -c to do the stripping.
148#
149my_processes="`ps -axco 'pid uid command' | grep -wEe '(VirtualBox|VirtualBoxVM|VBoxManage|VBoxHeadless|vboxwebsrv|VBoxXPCOMIPCD|VBoxSVC|VBoxNetDHCP|VBoxNetNAT)' | grep -vw grep | grep -vw VirtualBox_Uninstall.tool | tr '\n' '\a'`";
150if test -n "$my_processes"; then
151 echo 'Warning! Found the following active VirtualBox processes:'
152 echo "$my_processes" | tr '\a' '\n'
153 echo ""
154 echo "We recommend that you quit all VirtualBox processes before"
155 echo "uninstalling the product."
156 echo ""
157 if test "$my_default_prompt" != "Yes"; then
158 echo "Do you wish to continue none the less (Yes/No)?"
159 read my_answer
160 if test "$my_answer" != "Yes" -a "$my_answer" != "YES" -a "$my_answer" != "yes"; then
161 echo "Aborting uninstall. (answer: '$my_answer')".
162 exit 2;
163 fi
164 echo ""
165 my_answer=""
166 fi
167fi
168
169#
170# Display the files and directories that will be removed
171# and get the user's consent before continuing.
172#
173if test -n "${my_files[*]}" -o -n "${my_directories[*]}"; then
174 echo "The following files and directories (bundles) will be removed:"
175 for file in "${my_files[@]}"; do echo " $file"; done
176 for dir in "${my_directories[@]}"; do echo " $dir"; done
177 echo ""
178fi
179if test -n "${my_kexts[*]}"; then
180 echo "And the following KEXTs will be unloaded:"
181 for kext in "${my_kexts[@]}"; do echo " $kext"; done
182 echo ""
183fi
184if test -n "$my_pkgs"; then
185 echo "And the traces of following packages will be removed:"
186 for kext in $my_pkgs; do echo " $kext"; done
187 echo ""
188fi
189
190if test "$my_default_prompt" != "Yes"; then
191 echo "Do you wish to uninstall VirtualBox (Yes/No)?"
192 read my_answer
193 if test "$my_answer" != "Yes" -a "$my_answer" != "YES" -a "$my_answer" != "yes"; then
194 echo "Aborting uninstall. (answer: '$my_answer')".
195 exit 2;
196 fi
197 echo ""
198fi
199
200#
201# Unregister has to be done before the files are removed.
202#
203LSREGISTER=/System/Library/Frameworks/CoreServices.framework/Versions/A/Frameworks/LaunchServices.framework/Versions/A/Support/lsregister
204if [ -e ${LSREGISTER} ]; then
205 ${LSREGISTER} -u /Applications/VirtualBox.app > /dev/null
206 ${LSREGISTER} -u /Applications/VirtualBox.app/Contents/Resources/vmstarter.app > /dev/null
207fi
208
209#
210# Display the sudo usage instructions and execute the command.
211#
212echo "The uninstallation processes requires administrative privileges"
213echo "because some of the installed files cannot be removed by a normal"
214echo "user. You may be prompted for your password now..."
215echo ""
216
217if test -n "${my_files[*]}" -o -n "${my_directories[*]}"; then
218 /usr/bin/sudo -p "Please enter %u's password:" /bin/rm -Rf "${my_files[@]}" "${my_directories[@]}"
219 my_rc=$?
220 if test "$my_rc" -ne 0; then
221 echo "An error occurred durning 'sudo rm', there should be a message above. (rc=$my_rc)"
222 test -x /usr/bin/sudo || echo "warning: Cannot find /usr/bin/sudo or it's not an executable."
223 test -x /bin/rm || echo "warning: Cannot find /bin/rm or it's not an executable"
224 echo ""
225 echo "The uninstall failed. Please retry."
226 exit 1;
227 fi
228fi
229
230my_rc=0
231for kext in "${my_kexts[@]}"; do
232 echo unloading $kext
233 /usr/bin/sudo -p "Please enter %u's password (unloading $kext):" /sbin/kextunload -m $kext
234 my_rc2=$?
235 if test "$my_rc2" -ne 0; then
236 echo "An error occurred durning 'sudo /sbin/kextunload -m $kext', there should be a message above. (rc=$my_rc2)"
237 test -x /usr/bin/sudo || echo "warning: Cannot find /usr/bin/sudo or it's not an executable."
238 test -x /sbin/kextunload || echo "warning: Cannot find /sbin/kextunload or it's not an executable"
239 my_rc=$my_rc2
240 fi
241done
242if test "$my_rc" -eq 0; then
243 echo "Successfully unloaded VirtualBox kernel extensions."
244else
245 echo "Failed to unload one or more KEXTs, please reboot the machine to complete the uninstall."
246 exit 1;
247fi
248
249# Cleaning up pkgutil database
250for my_pkg in $my_pkgs; do
251 /usr/bin/sudo -p "Please enter %u's password (removing $my_pkg):" /usr/sbin/pkgutil --forget "$my_pkg"
252done
253
254echo "Done."
255exit 0;
256
Note: See TracBrowser for help on using the repository browser.

© 2025 Oracle Support Privacy / Do Not Sell My Info Terms of Use Trademark Policy Automated Access Etiquette